
/*
  Demo using wrappers in Tlbx SQLite3Expanded.incl
  Bernie 2013-04-08

  This file and Tlbx SQLite3Expanded.incl updated.
  N.B. Build with compiler options "-m64 -lsqlite3"
  Brian 2019-04-05

  Updated for FB 7.0.11, 20220215 bw
*/

include "Tlbx SQLite3Expanded.incl"

#define DB_PATH fn URLPath( fn URLByAppendingPathComponent( fn FileManagerURLForDirectory( NSDocumentDirectory, NSUserDomainMask ), @"MySQL3DB" ) )

local fn DoIt

CFStringRef       task
sqlite3Ptr        db
sqlite3_stmtPtr   statement
long              rc, priority

window 1, @"SQLiteDemoExpanded", (0,0,480,360)

// announce
printf @"SQLite version: %d",fn SQL3LibVersionNumber

// open
printf @"Path: %@", DB_PATH
rc = fn SQL3Open( DB_PATH, @db )
if ( rc )
printf @"  Error result = %d", rc
xelse
// populate
fn SQL3Exec( db, @"DROP TABLE IF EXISTS memos;" )
fn SQL3Exec( db, @"CREATE TABLE memos( task TEXT, priority INTEGER );" )
fn SQL3Exec( db, @"INSERT INTO memos VALUES( 'Finish this demo', 10 );" )
fn SQL3Exec( db, @"INSERT INTO memos VALUES( 'Post to FB List', 5 );" )
fn SQL3Exec( db, @"INSERT INTO memos VALUES( 'Open bottle of wine', 100 );" )

// query how many rows changed
printf @"Rows changed: %d", fn SQL3TotalChanges( db )

// display
print
rc = fn SQL3PrepareV2( db, @"SELECT task, priority FROM memos", @statement )
if ( rc == _SQLITEOK )
while ( fn SQL3Step( statement ) == _SQLITEROW )
task = fn SQL3ColumnText( statement, 0 )
priority = fn SQL3ColumnInt( statement, 1 )
printf @"%@\t%i", task, priority
wend
fn SQL3Finalize( statement )
end if

// close
fn SQL3Close( db )
end if
end fn

fn DoIt

HandleEvents

